from typing import ClassVar, Optional, Union

from .chandle import CHandle
from .internals import CorrelationId
from .message import Message
from .resolutionlist import ResolutionList

class TopicList(CHandle):
    NOT_CREATED: ClassVar[int]
    CREATED: ClassVar[int]
    FAILURE: ClassVar[int]
    def __init__(self, original: Optional[ResolutionList] = ...) -> None: ...
    def add(
        self,
        topicOrMessage: Union[str, Message],
        correlationId: Optional[CorrelationId] = ...,
    ) -> int: ...
    def correlationIdAt(self, index: int) -> CorrelationId: ...
    def topicString(self, correlationId: CorrelationId) -> str: ...
    def topicStringAt(self, index: int) -> str: ...
    def status(self, correlationId: CorrelationId) -> int: ...
    def statusAt(self, index: int) -> int: ...
    def message(self, correlationId: CorrelationId) -> Message: ...
    def messageAt(self, index: int) -> Message: ...
    def size(self) -> int: ...
